CT_InventorySlots = {
	{ slot = "HeadSlot", hasbuff = 0 },
	{ slot = "NeckSlot", hasbuff = 0 },
	{ slot = "ShoulderSlot", hasbuff = 0 },
	{ slot = "BackSlot", hasbuff = 0 },
	{ slot = "ChestSlot", hasbuff = 0 },
	{ slot = "ShirtSlot", hasbuff = 0 },
	{ slot = "TabardSlot", hasbuff = 0 },
	{ slot = "WristSlot", hasbuff = 0 },
	{ slot = "HandsSlot", hasbuff = 0 },
	{ slot = "WaistSlot", hasbuff = 0 },
	{ slot = "LegsSlot", hasbuff = 0 },
	{ slot = "FeetSlot", hasbuff = 0 },
	{ slot = "Finger0Slot", hasbuff = 0 },
	{ slot = "Finger1Slot", hasbuff = 0 },
	{ slot = "Trinket0Slot", hasbuff = 0 },
	{ slot = "Trinket1Slot", hasbuff = 0 },
	{ slot = "MainHandSlot", hasbuff = 0 },
	{ slot = "SecondaryHandSlot", hasbuff = 0 },
	{ slot = "RangedSlot", hasbuff = 0 }
};
CT_ItemBuff_MinBuffMessageTime = 16;
CT_ItemBuff_MinBuffDuration = 15;

-- Credits to Telo for the following 2 functions
local CT_GameTooltip_ClearMoney;

local function CT_ItemBuff_MoneyToggle()
	if( CT_GameTooltip_ClearMoney ) then
		GameTooltip_ClearMoney = CT_GameTooltip_ClearMoney;
		CT_GameTooltip_ClearMoney = nil;
	else
		CT_GameTooltip_ClearMoney = GameTooltip_ClearMoney;
		GameTooltip_ClearMoney = CT_GameTooltipFunc_ClearMoney;
	end
end

function CT_GameTooltipFunc_ClearMoney()

end

function CT_ItemBuffButton_OnUpdate(elapsed)
	if ( not CT_BuffFrame:IsVisible() ) then
		this:Hide();
		return;
	end
	this.update = this.update + elapsed;
	if ( this.update < 1 ) then return; end

	this.update = this.update - 1;

	local i;

	local duration, name, timeLeft = CT_GetItemBuffStats(CT_InventorySlots[this.slotid].id);

	if ( not duration ) then
		if ( this.slotid > 0 ) then
			CT_InventorySlots[this.slotid].hasbuff = 0;
		end
		this.slotid = 0;
		this:Hide();
		return;
	end
	if ( this.slotid == 0 ) then
		return;
	else
		getglobal(this:GetName() .. "DescribeText"):SetText(name);
		getglobal(this:GetName() .. "DurationText"):SetText(duration);
	end
	if ( CT_ShowDuration ) then
		getglobal(this:GetName() .. "DurationText"):Show();
	else
		getglobal(this:GetName() .. "DurationText"):Hide();
	end

	if ( timeLeft == CT_ItemBuff_MinBuffMessageTime ) then
		CT_ExpireBuffs[name] = 1;
	end

	if ( timeLeft == ExpireMessageTime and CT_ExpireBuffs[name] and CT_ExpireBuffs[name] == 1 ) then
		CT_ExpireBuffs[name] = nil;
		if ( CT_ShowExpire == 1 ) then
			local message = format( ExpireMessageString, name );
			CT_Print( message, ExpireMessageColors["r"], ExpireMessageColors["g"], ExpireMessageColors["b"] );
		end
	end
	if ( timeLeft < BuffStartFlashTime ) then
		if ( BuffFlashState == 1 ) then
			buffAlphaValue = (BuffFlashOn - BuffFlashTime) / BuffFlashOn;
			buffAlphaValue = buffAlphaValue * (1 - BuffMinOpacity) + BuffMinOpacity;
		else
			buffAlphaValue = BuffFlashTime / BuffFlashOn;
			buffAlphaValue = (buffAlphaValue * (1 - BuffMinOpacity)) + BuffMinOpacity;
			this:SetAlpha(BuffFlashTime / BuffFlashOn);
		end
		this:SetAlpha(buffAlphaValue);
	else
		this:SetAlpha(1.0);
	end
end

function CT_ItemBuffFrame_OnLoad()
	local i;
	for i = 1, getn(CT_InventorySlots), 1 do
		CT_InventorySlots[i].id = GetInventorySlotInfo(CT_InventorySlots[i].slot);
	end
	
end

function CT_ItemBuffs_ItemHasItemBuff(itemid)
	local text, i, val;

	CT_ItemBuff_MoneyToggle();
	val = CT_IB_TempTooltip:SetInventoryItem("player", itemid)
	CT_ItemBuff_MoneyToggle();

	if ( val ) then
		for i = 1, 15, 1 do
			text = getglobal("CT_IB_TempTooltipTextLeft"..i);
			if ( text:IsVisible() ) then
				text = text:GetText();
				if ( text and string.find(text, "%((%d+) min%)") or string.find(text, "%((%d+) sec%)") ) then
					return 1;
				end
			end
		end
	end
	return nil;
end

function CT_ItemBuffFrame_OnUpdate(elapsed)
	if ( not CT_BuffFrame:IsVisible() ) then
		return;
	end
	this.update = this.update + elapsed;
	if ( this.update < 1 ) then return; end

	this.update = this.update - 1;
	local i, j;
	for i = 1, getn(CT_InventorySlots), 1 do
		local dur, name, timeLeft = CT_GetItemBuffStats(CT_InventorySlots[i].id);
		if ( CT_InventorySlots[i].hasbuff == 0 and timeLeft and timeLeft > CT_ItemBuff_MinBuffDuration ) then
			CT_InventorySlots[i].hasbuff = 1;
			for j = 0, 3, 1 do
				if ( not getglobal("CT_ItemBuffButton" .. j ):IsVisible() ) then
					local btn = getglobal("CT_ItemBuffButton" .. j);
					btn:Show();
					btn.slotid = i;
					getglobal(btn:GetName() .. "Icon"):SetTexture(GetInventoryItemTexture("player", CT_InventorySlots[i].id));
					break;
				end
			end
		end
	end
	if ( not CT_BuffButton0:IsVisible() ) then
		CT_ItemBuffButton0:SetPoint("TOPLEFT", "CT_BuffButton0", "TOPLEFT", 0, 0);
	else
		for i = 0, 23, 1 do
			if ( not getglobal("CT_BuffButton" .. i):IsVisible() ) then
				CT_ItemBuffButton0:SetPoint("TOPLEFT", "CT_BuffButton" .. (i-1), "BOTTOMLEFT", 0, -5);
				break;
			end
		end
	end
end

local function CT_ItemBuff_FixString(num, type, charges)
	local chargestring = "";
	if ( charges == 1 ) then
		chargestring = " 1 charge";
		charges = 2;
	elseif ( charges > 1 ) then
		chargestring = " " .. charges .. " charges";
		charges = 2;
	end

	local types = {
		{ "minute", "second", "min", "sec" },
		{ "minutes", "seconds", "min", "sec" }
	};

	if ( num == 1 ) then
		return num .. " " .. types[1][(type+charges)] .. chargestring;
	else
		return num .. " " .. types[2][(type+charges)] .. chargestring;
	end
end

function CT_GetItemBuffStats(buttonid)
	local i, text, durtext;
	local iStart, iEnd, temp, num;

	CT_ItemBuff_MoneyToggle();
	local val = CT_IB_TempTooltip:SetInventoryItem("player", buttonid)
	CT_ItemBuff_MoneyToggle();

	if ( val ) then
		for i = 1, 15, 1 do
			text = getglobal("CT_IB_TempTooltipTextLeft"..i);
			if ( text:IsVisible() ) then
				text = text:GetText();
				if ( text ) then
					local useless, useless, charges = string.find(text, "%((%d+) " .. CT_ITEMBUFFS_CHARGE .. "s%)");
					if ( not charges ) then
						useless, useless, charges = string.find(text, "%((%d+) " .. CT_ITEMBUFFS_CHARGE .. "%)");
						if ( not charges ) then	charges = 0; end
					end

					iStart, iEnd, temp = string.find(text, "%((%d+) " .. CT_ITEMBUFFS_MINUTE .. "%)")
					if( temp ) then
						durtext = CT_ItemBuff_FixString(tonumber(temp), 1, tonumber(charges));
						num = tonumber(temp)*60;
					end

					iStart, iEnd, temp = string.find(text, "%((%d+) " .. CT_ITEMBUFFS_SECOND .. "%)")
					if( temp ) then
						durtext = CT_ItemBuff_FixString(tonumber(temp), 2, tonumber(charges));
						num = tonumber(temp);
					end

					iStart, iEnd, temp = string.find(text, "^([^%(]+) %(.+%)$");
					if ( temp and durtext and num ) then
						return durtext, temp, num;
					end
				end
			end
		end
	end
	return nil;
end

function CT_ItemBuffs_InitFunc(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_ItemBuff_MinBuffDuration = 0;
	else
		CT_ItemBuff_MinBuffDuration = 16;
	end
end

function CT_ItemBuffs_Func(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_Print("<CTMod> Short duration buffs are now shown.", 1, 1, 0);
		CT_ItemBuff_MinBuffDuration = 0;
	else
		CT_Print("<CTMod> Short duration buffs are now hidden.", 1, 1, 0);
		CT_ItemBuff_MinBuffDuration = 16;
	end
end

CT_RegisterMod(CT_ITEMBUFFS_MODNAME, CT_ITEMBUFFS_SUBNAME, 3, "Interface\\Icons\\INV_Misc_PocketWatch_01", CT_ITEMBUFFS_TOOLTIP, "off", nil, CT_ItemBuffs_Func, CT_ItemBuffs_InitFunc);

-- Hook our own function ;)

CT_Old_SwapSides = CT_Buffs_SwapSides;

function CT_ItemBuffs_SwapSides(onLoad)
	CT_Old_SwapSides(onLoad);
	local i;
	for i = 0, 3, 1 do
		getglobal("CT_ItemBuffButton" .. i .. "DescribeText"):ClearAllPoints();
		getglobal("CT_ItemBuffButton" .. i .. "DurationText"):ClearAllPoints();
		if ( CT_BuffMod_BuffSides == "LEFT" or onLoad ) then
			getglobal("CT_ItemBuffButton" .. i .. "DescribeText"):SetPoint("RIGHT", "CT_ItemBuffButton" .. i, "LEFT", -8, 7);
			getglobal("CT_ItemBuffButton" .. i .. "DurationText"):SetPoint("RIGHT", "CT_ItemBuffButton" .. i, "LEFT", -8, -7);
		elseif ( CT_BuffMod_BuffSides == "RIGHT" ) then
			getglobal("CT_ItemBuffButton" .. i .. "DescribeText"):SetPoint("LEFT", "CT_ItemBuffButton" .. i, "LEFT", 40, 7);
			getglobal("CT_ItemBuffButton" .. i .. "DurationText"):SetPoint("LEFT", "CT_ItemBuffButton" .. i, "LEFT", 40, -7);
		end
	end
end

CT_Buffs_SwapSides = CT_ItemBuffs_SwapSides;